#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_SevenDayActivityCFG.h"
std::auto_ptr<M_SevenDayActivityCFG> M_SevenDayActivityCFG::msSingleton(nullptr);

int M_SevenDayActivityCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_SevenDayActivityCFGData* M_SevenDayActivityCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_SevenDayActivityCFGData>& M_SevenDayActivityCFG::GetMapData()
{
	return mMapData;
}

void M_SevenDayActivityCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_SevenDayActivityCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_SevenDayActivityCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mDesc = element->Attribute("Desc");
		data.mClass = element->IntAttribute("Class");
		data.mDay = element->IntAttribute("Day");
		data.mCompleteType = element->IntAttribute("CompleteType");
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mCompleteParam = element->IntAttribute("CompleteParam");
		{
			const char* AwardItemIDs = element->Attribute("AwardItemIDs");
			std::vector<std::string> vecAwardItemIDs;
			boost::split(vecAwardItemIDs, AwardItemIDs, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemIDs.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemIDs[i].c_str(), &temp))
				{
					data.mAwardItemIDs.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mCombinationQuestID = element->IntAttribute("CombinationQuestID");
		{
			const char* CombinationQuests = element->Attribute("CombinationQuests");
			std::vector<std::string> vecCombinationQuests;
			boost::split(vecCombinationQuests, CombinationQuests, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCombinationQuests.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCombinationQuests[i].c_str(), &temp))
				{
					data.mCombinationQuests.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_SevenDayActivityCFG Loaded. Load Data:%u", mMapData.size());
}

void M_SevenDayActivityCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_SevenDayActivityCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_SevenDayActivityCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_SevenDayActivityCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "Class", data.mClass);
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readVectorInt(L, "AwardItemIDs", data.mAwardItemIDs);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "CombinationQuestID", data.mCombinationQuestID);
		LuaCfgHelper::readVectorInt(L, "CombinationQuests", data.mCombinationQuests);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_SevenDayActivityCFG Loaded. Load Data:%u", mMapData.size());
}

void M_SevenDayActivityCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_SevenDayActivityCFG* M_SevenDayActivityCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_SevenDayActivityCFG());
	}
	return msSingleton.get();
}

void M_SevenDayActivityCFG::Release()
{
	msSingleton.reset(nullptr);
}
